var http = require("http"),
    url = require("url"),
    tokens = {};

module.exports = Authority;

function Authority(opts) {
	return {
		authenticate: function (username, password, cb) {
			if (username != opts.username) {
				return cb(null, false);
			}

			return cb(null, opts);
		},
		check: function (token, cb) {
			
		}
	};
}

function requestToken(opts, cb) {
	var req = http.request(url.parse(opts.request_token_endpoint), function (res) {
		var data = "";

		res.setEncoding("utf8");
		res.on("data", function (chunk) {
			data += String(chunk);
		});
		res.on("end", function () {
			try {
				data = JSON.parse(data);
			} catch (e) {
				return cb(e);
			}

			tokens[data.oauth_token] = {
				 secret: data.oauth_token_secret,
				expires: data.expires || Date.now() + 60000
			};

			return cb(null, opts.authorize_endpoint.replace("%token", e.oauth_token));
		});
	});
	req.on("error", function (err) {
		return cb(err);
	});
	req.end();
}